<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 01/09/2005 *
 * ===================                          Last change: 01/09/2005 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-extensions.php                              *
 * -------------------------------------------------------------------- *
 * Short description : Lists all extension's description texts          *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Listet alle Beschreibungstexte aller Erw. auf    *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009 - 2013 by Mailer Developer Team                   *
 * For more information visit: http://mxchange.org                      *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	exit();
} // END - if

// Add description as navigation point
addYouAreHereLink('guest', __FILE__);

// Get all extension files
$extensions = loadAllExtensionsByTemplate();

// Now iterate through all and load that template file
$OUT = '';
foreach ($extensions as $ext_file) {
	// We only need the filename
	$template = substr(basename($ext_file), 0, -4);

	// Prepare data
	$content = array(
		'name'        => substr($template, 4),
		'description' => loadTemplate($template, TRUE),
	);

	// Load the template in a special row template
	$OUT .= loadTemplate('guest_extensions_row', TRUE, $content);
} // END - foreach

// Load main template
loadTemplate('guest_extensions', FALSE, $OUT);

// [EOF]
?>
